#include <stdio.h>
#include <Xm/MessageB.h>
#include "jex.h"

extern Widget top;

void Function(void (*f)(),Editor *e)
{
SP("Function");
  if (f)
    f(e);
EP;
}

void NoSave(Widget w,Editor *e,void *cbs)
{
SP("NoSave");
  if (e->f!=NULL)
    Function((void(*)(void))e->f,e);
EP;
}  

void CancelAskToSave(Widget w,Editor *e,void *cbs)
{
SP("CancelAskToSave");
  XtUnmanageChild(e->ats);
  SetCurrentWidget(e->text);
EP;
}

void AskToSaveOK(Widget w,Editor *e,void *cbs)
{
SP("AskToSaveOK");
  Save(NULL,e,e->f);
  SetCurrentWidget(e->text);
EP;
}

void AskToSave(Editor *e,void *f)
{
SP("AskToSave");
  if (e->ats==NULL)
  {
    e->ats=XmCreateQuestionDialog(e->shell,"AskToSave",NULL,0);
    e->f=f;
    XtAddCallback(e->ats,XmNokCallback,(XtCallbackProc)AskToSaveOK,e);
    XtAddCallback(e->ats,XmNcancelCallback,(XtCallbackProc)NoSave,e);
    XtAddCallback(e->ats,XmNhelpCallback,(XtCallbackProc)CancelAskToSave,e);
  }
  else
  {
    XtRemoveAllCallbacks(e->ats,XmNokCallback);
    XtRemoveAllCallbacks(e->ats,XmNcancelCallback);
    XtRemoveAllCallbacks(e->ats,XmNhelpCallback);
    e->f=f;
    XtAddCallback(e->ats,XmNokCallback,(XtCallbackProc)AskToSaveOK,e);
    XtAddCallback(e->ats,XmNcancelCallback,(XtCallbackProc)NoSave,e);
    XtAddCallback(e->ats,XmNhelpCallback,(XtCallbackProc)CancelAskToSave,e);
  }
  XtManageChild(e->ats);
EP;
}  
