#include <Xm/MessageB.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/DrawnB.h>
#include <Xm/PushBG.h>
#include <Xm/List.h>
#include <signal.h>
#include <sys/param.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <sys/time.h>
#include <unistd.h>
#include "list.h"
#include "jex.h"

extern List f_list;
extern int subdirs,grep_size,grep_file_size,case_sensitive,do_replace;
extern XtAppContext app;
extern Pixmap lov;
extern Widget combo4,combo5,combo6;

void GrepOK(Widget wdg,Editor *e,void *cbs)
{
  char *what;
  char *where;
  char *repl="";
  char str[255];
  Boolean subdir,casesens,replace;
  char *args[20];
  int x,pid;
  
SP("GrepOK");
  XtVaGetValues(e->gpat,XmNvalue,&what,NULL);
  if (what[0]=='\0')
  {
    XtFree(what);
EP;
    return;
  }
  UpdateComboBox(combo4,what);
  for (x=0;x<editors;x++)
    UpdateComboBox(editor[x]->gpat,what);
/*  UpdateGrepList(what);*/
  XtVaSetValues(e->compile,XmNsensitive,False,NULL);  
  XtVaSetValues(e->make,XmNsensitive,False,NULL); 
  XtVaSetValues(e->run,XmNsensitive,False,NULL); 
  XtVaSetValues(e->grep,XmNsensitive,False,NULL);  
#ifndef LESSTIFF    
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,False,NULL);
#endif
  XtVaGetValues(e->gfiles,XmNvalue,&where,NULL);
  if (where[0]=='\0')
  {
    XtFree(where);
    where=(char*)XtMalloc(2);
    db_strcpy(where,"*");
  }
  XtVaGetValues(XtNameToWidget(e->gd,"*GrepReplace"),XmNset,&replace,NULL);
  if (replace)
  {
    do_replace=replace?1:0;
#ifndef LESSTIFF    
    XtVaGetValues(XtNameToWidget(e->gd,"*GrepReplaceField"),XmNvalue,&repl,NULL);
#endif
    UpdateComboBox(combo6,repl);
    for (x=0;x<editors;x++)
    {
#ifndef LESSTIFF    
      if (XtNameToWidget(editor[x]->gd,"*GrepReplaceField"))
        UpdateComboBox(XtNameToWidget(editor[x]->gd,"*GrepReplaceField"),repl);
#endif
    }
  }
  UpdateComboBox(combo5,where);
  for (x=0;x<editors;x++)
    UpdateComboBox(editor[x]->gfiles,where);
/*  UpdateGrepFileList(where);*/
  XtVaGetValues(e->gsubd,XmNset,&subdir,NULL);
  XtVaGetValues(e->casesens,XmNset,&casesens,NULL);
  SplitUp(where,args);
  e->t.pid=0;
  CreateOutputWindow(e); 
  XtPopup(e->iod,XtGrabNone);
  XMapRaised(XtDisplay(e->iod),XtWindow(e->iod));
  XmListDeleteAllItems(e->io_win);
  e->x=0;
  SetLabel(e,"Grep");
  if (db_pipe(e->t.fd)!=0)
  {
    SetLabel(e,"Too many open files!");
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);  
    XtVaSetValues(e->make,XmNsensitive,True,NULL);  
    XtVaSetValues(e->run,XmNsensitive,True,NULL);  
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
    if (replace)
      XtFree(repl);
EP;
    return;
  }
  if (db_pipe(e->t.fd2)!=0)
  {
    SetLabel(e,"Too many open files!");
    db_close(e->t.fd[0]);
    db_close(e->t.fd[1]);
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);
    XtVaSetValues(e->make,XmNsensitive,True,NULL);
    XtVaSetValues(e->run,XmNsensitive,True,NULL);
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
    if (replace)
      XtFree(repl);
EP;
    return;
  }
  if (db_pipe(e->t.fd3)!=0)
  {
    SetLabel(e,"Too many open files!");
    db_close(e->t.fd[0]);
    db_close(e->t.fd[1]);
    db_close(e->t.fd2[0]);
    db_close(e->t.fd2[1]);
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);
    XtVaSetValues(e->make,XmNsensitive,True,NULL);
    XtVaSetValues(e->run,XmNsensitive,True,NULL);
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
EP;
    return;
  }

  e->tid=XtAppAddTimeOut(app,500,(XtTimerCallbackProc)SetWorkingLabel,(void*)e);

  fcntl(e->t.fd[0],F_SETFL,O_NONBLOCK);
  fcntl(e->t.fd2[0],F_SETFL,O_NONBLOCK);

  e->t.id=XtAppAddInput(app,e->t.fd[0],(XtPointer)XtInputReadMask,(XtInputCallbackProc)InputCallback1,(XtPointer)e);
  e->t.id2=XtAppAddInput(app,e->t.fd2[0],(XtPointer)XtInputReadMask,(XtInputCallbackProc)InputCallback2,(XtPointer)e);

  db_strcpy(e->t.name,"Grep");
  signal(SIGCHLD,ChildSignal);

  if ((pid=fork())>=0)
  {
    if (pid>0)
    {
      e->t.pid=pid;
      XtFree(what);
      XtFree(where);
      e->grepped=1;
    }
    if (pid==0)
    {
      db_postmortemdump=0;
      signal(SIGQUIT,SIG_DFL);
      signal(SIGILL,SIG_DFL);
      signal(SIGTRAP,SIG_DFL);
      signal(SIGIOT,SIG_DFL);
      signal(SIGFPE,SIG_DFL);
      signal(SIGKILL,SIG_DFL);
      signal(SIGBUS,SIG_DFL);
      signal(SIGSEGV,SIG_DFL);
      signal(SIGTERM,SIG_DFL);
      signal(SIGHUP,SIG_DFL);
      signal(SIGSTOP,SIG_DFL);
      signal(SIGINT,SIG_DFL);
      signal(SIGIO,SIG_DFL);
      signal(SIGPIPE,SIG_DFL);
      signal(SIGUSR1,SIG_DFL);
      signal(SIGUSR2,SIG_DFL);
      signal(SIGPROF,SIG_DFL);
      signal(SIGABRT,SIG_DFL);
      db_setbuf(stdout,NULL);
      db_dup2(e->t.fd[1],1);
      db_dup2(e->t.fd2[1],2);
      db_dup2(e->t.fd3[0],0);
      subdirs=subdir;
      case_sensitive=casesens;
      f_list=CreateList(255);
      x=0;
      while (args[x])
      {
        db_strcpy(str,args[x]);
        AddElement(f_list,str);
        x++;
      }
      DoGrep(what,repl);
      DisposeList(f_list);
      exit(0);
    }
  }
  else
  {
    SetLabel(e,"fork() failed!");
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);  
    XtVaSetValues(e->make,XmNsensitive,True,NULL);  
    XtVaSetValues(e->run,XmNsensitive,True,NULL);  
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
EP;
    return;
  }
EP;}

void GrepCancel(Widget w,Editor *e,void *cbs)
{
  SetCurrentWidget(e->text);
}

void ReplaceActive(Widget w,Widget f,XmToggleButtonCallbackStruct *cbs)
{
  SP("ReplaceActive");
  XtVaSetValues(f,XmNsensitive,(Boolean)cbs->set,NULL);
  EP;
}

void Grep(Widget wdg,Editor *e,void *cbs)
{
  Widget f,w1,w2,w3,w;
  int n;
  Arg arg[10];

SP("Grep");
  WatchCursor(e,1);
  if (e->gd==NULL)
  {
    e->gd=XmCreateMessageDialog(e->shell,"GrepDialog",NULL,0);
    XtAddCallback(e->gd,XmNokCallback,(XtCallbackProc)GrepOK,(void*)e);
    XtAddCallback(e->gd,XmNcancelCallback,(XtCallbackProc)GrepCancel,(void*)e);
    XtAddCallback(e->gd,XmNhelpCallback,(XtCallbackProc)Help,"Grep");
    f=XtVaCreateManagedWidget("GrepForm",xmFormWidgetClass,e->gd,
    	XmNfractionBase,3,NULL);
    w1=XtVaCreateManagedWidget("GrepPatLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNtopOffset,5,
	XmNalignment,XmALIGNMENT_BEGINNING,
    	NULL);
    n=0;
    XtSetArg(arg[n],XmNtopAttachment,XmATTACH_FORM);n++;
    XtSetArg(arg[n],XmNleftAttachment,XmATTACH_WIDGET);n++;
    XtSetArg(arg[n],XmNleftWidget,w1);n++;
    XtSetArg(arg[n],XmNrightAttachment,XmATTACH_FORM);n++;
    e->gpat=CreateComboBox(f,"GrepPattern",arg,n,10);
    InitializeComboBox(e->gpat,combo4);
    w3=XtVaCreateManagedWidget("GrepFileLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,XtParent(e->gpat),
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_OPPOSITE_WIDGET,
    	XmNrightWidget,w1,
    	XmNtopOffset,5,
	XmNalignment,XmALIGNMENT_BEGINNING,
    	NULL);
    	
    n=0;
    XtSetArg(arg[n],XmNtopAttachment,XmATTACH_WIDGET);n++;	  
    XtSetArg(arg[n],XmNtopWidget,XtParent(e->gpat));n++;	  
    XtSetArg(arg[n],XmNleftAttachment,XmATTACH_WIDGET);n++;	  
    XtSetArg(arg[n],XmNleftWidget,w3);n++;	  
    XtSetArg(arg[n],XmNrightAttachment,XmATTACH_FORM);n++;	  
    e->gfiles=CreateComboBox(f,"GrepFiles",arg,n,10);
    InitializeComboBox(e->gfiles,combo5);

    w2=XtVaCreateManagedWidget("GrepReplace",xmToggleButtonWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,XtParent(e->gfiles),
    	XmNleftAttachment,XmATTACH_FORM,
	NULL);
    w3=XtVaCreateManagedWidget("GrepReplaceLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,w2,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_OPPOSITE_WIDGET,
    	XmNrightWidget,w1,
    	XmNtopOffset,5,
	XmNalignment,XmALIGNMENT_BEGINNING,
    	NULL);
    n=0;
    XtSetArg(arg[n],XmNtopAttachment,XmATTACH_WIDGET);n++;
    XtSetArg(arg[n],XmNtopWidget,w2);n++;
    XtSetArg(arg[n],XmNleftAttachment,XmATTACH_WIDGET);n++;
    XtSetArg(arg[n],XmNleftWidget,w3);n++;
    XtSetArg(arg[n],XmNrightAttachment,XmATTACH_FORM);n++;
    w=CreateComboBox(f,"GrepReplaceField",arg,n,10);
    InitializeComboBox(w,combo6);
    XtAddCallback(w2,XmNvalueChangedCallback,(XtCallbackProc)ReplaceActive,(void*)w);
    	
    e->gsubd=XtVaCreateManagedWidget("GrepSubDirs",xmToggleButtonWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,XtParent(w),
    	XmNleftAttachment,XmATTACH_FORM,
	NULL);
    e->casesens=XtVaCreateManagedWidget("GrepCase",xmToggleButtonWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->gsubd,
    	XmNleftAttachment,XmATTACH_FORM,
	NULL);
  }
  XtManageChild(e->gd);
  WatchCursor(e,0);
EP;
}


