#ifndef _HELPSTACK_H_
#define _HELPSTACK_H_

typedef struct  {
		  char data[40];
		} HStackElem;

typedef struct HStackElement {
	HStackElem s;
	struct HStackElement *prev;
       } HStackElement;	 
		 

typedef struct {
		int nelems;
		HStackElement *last;
  	       } HStack;

HStack *CreateHStack(void);
void DestroyHStack(HStack *hst);
int Push(HStack *hst,HStackElem data);
int Pop(HStack *hst,HStackElem *data);
int HStackN(HStack *hst,int offset,HStackElem *data);
int StackSize(HStack *hst);
void StackClear(HStack *hst);

#endif
