#include <Xm/MessageB.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include "jex.h"
#include "xpm.h"
#include "jexlogo.xpm"
#include "jexrlogo.xpm"

Pixmap logo=0,logo2;
extern Widget top;

void AboutOK(Widget w,Editor *e,void *cbs)
{
  SetCurrentWidget(e->text);
}

void ShowAboutDialog(Editor *e)
{
  Widget w,f,l,l2;
  Pixel fg,bg;
  XmString xstr;
  char version[30];

SP("ShowAboutDialog");
  WatchCursor(e,1);
  if (!e->abd)
  {
    e->abd=XmCreateMessageDialog(e->shell,"About",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(e->abd,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(e->abd,XmDIALOG_HELP_BUTTON));
    XtAddCallback(e->abd,XmNokCallback,(XtCallbackProc)AboutOK,(void*)e);
    if (!logo)
    {
      XtVaGetValues(e->abd,XmNforeground,&fg,XmNbackground,&bg,NULL);
/*      logo=XCreatePixmapFromBitmapData(XtDisplay(top),
		  RootWindowOfScreen(XtScreen(top)),
		  jexlogo_bits,jexlogo_width,jexlogo_height,
		  fg,bg,
		  DefaultDepthOfScreen(XtScreen(top)));
      logo2=XCreatePixmapFromBitmapData(XtDisplay(top),
		  RootWindowOfScreen(XtScreen(top)),
		  jexrlogo_bits,jexrlogo_width,jexrlogo_height,
		  fg,bg,
		  DefaultDepthOfScreen(XtScreen(top)));*/
      logo=CreatePixmapFromXPM(top,jexlogo_xpm);
      logo2=CreatePixmapFromXPM(top,jexrlogo_xpm);
		  
    }
    f=XtVaCreateManagedWidget("aboutform",xmFormWidgetClass,e->abd,
        XmNfractionBase,8,
    	NULL);
    l=XtVaCreateManagedWidget("aboutlogo",xmLabelWidgetClass,f,
    	XmNlabelType,XmPIXMAP,
    	XmNlabelPixmap,logo,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_NONE,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_FORM,
    	NULL);
    l2=XtVaCreateManagedWidget("aboutlogo2",xmLabelWidgetClass,f,
    	XmNlabelType,XmPIXMAP,
    	XmNlabelPixmap,logo2,
    	XmNleftAttachment,XmATTACH_NONE,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_FORM,
    	NULL);
    xstr=XmStringCreateLocalized("JEX");
    w=XtVaCreateManagedWidget("about1",xmLabelWidgetClass,f,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,l,
    	XmNrightAttachment,XmATTACH_WIDGET,
    	XmNrightWidget,l2,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_POSITION,
    	XmNbottomPosition,2,
        XmNleftOffset,20,
        XmNrightOffset,20,
        XmNlabelString,xstr,
	NULL);
    XmStringFree(xstr);
    xstr=XmStringCreateLocalized("Jorgen Editor for X");
    w=XtVaCreateManagedWidget("about2",xmLabelWidgetClass,f,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,l,
    	XmNrightAttachment,XmATTACH_WIDGET,
    	XmNrightWidget,l2,
    	XmNtopAttachment,XmATTACH_POSITION,
    	XmNtopPosition,2,
    	XmNbottomAttachment,XmATTACH_POSITION,
    	XmNbottomPosition,3,
        XmNleftOffset,20,
        XmNrightOffset,20,
        XmNlabelString,xstr,
	NULL);
    XmStringFree(xstr);
    xstr=XmStringCreateLocalized("A programmer's editor");
    w=XtVaCreateManagedWidget("about3",xmLabelWidgetClass,f,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,l,
    	XmNrightAttachment,XmATTACH_WIDGET,
    	XmNrightWidget,l2,
    	XmNtopAttachment,XmATTACH_POSITION,
    	XmNtopPosition,3,
    	XmNbottomAttachment,XmATTACH_POSITION,
    	XmNbottomPosition,4,
        XmNleftOffset,20,
        XmNrightOffset,20,
        XmNlabelString,xstr,
	NULL);
    XmStringFree(xstr);
    sprintf(version,"Version %d.%d.%d",MAJOR_VERSION,MINOR_VERSION,SUB_MINOR_VERSION);
    xstr=XmStringCreateLocalized(version);
    w=XtVaCreateManagedWidget("about4",xmLabelWidgetClass,f,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,l,
    	XmNrightAttachment,XmATTACH_WIDGET,
    	XmNrightWidget,l2,
    	XmNtopAttachment,XmATTACH_POSITION,
    	XmNtopPosition,5,
    	XmNbottomAttachment,XmATTACH_POSITION,
    	XmNbottomPosition,6,
        XmNleftOffset,20,
        XmNrightOffset,20,
        XmNlabelString,xstr,
	NULL);
    XmStringFree(xstr);
    xstr=XmStringCreateLocalized("(c) 1996-1998 by Jorgen Bosman");
    w=XtVaCreateManagedWidget("about5",xmLabelWidgetClass,f,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,l,
    	XmNrightAttachment,XmATTACH_WIDGET,
    	XmNrightWidget,l2,
    	XmNtopAttachment,XmATTACH_POSITION,
    	XmNtopPosition,7,
    	XmNbottomAttachment,XmATTACH_FORM,
        XmNleftOffset,20,
        XmNrightOffset,20,
        XmNlabelString,xstr,
	NULL);
    XmStringFree(xstr);
  }
  XtManageChild(e->abd);
  WatchCursor(e,0);
EP;
}

