#include <Xm/Xm.h>

typedef struct {
		 char *item;
		 Widget button;
               } ComboButton;

typedef struct {
		 Widget text,form,button,popup;
		 ComboButton *items;
		 int itemcount,maxitems;
		 void *client_data;
		 XtCallbackProc function;
               } ComboBox;

Widget CreateComboBox(Widget parent,String name,ArgList arglist,Cardinal argcount,int maxitems);
void UpdateComboBox(Widget w,char *str);
void DestroyAllComboBoxes(void);
int GetComboBox(Widget w,ComboBox *c);
void InitializeComboBox(Widget w,Widget refl);
void CopyComboBoxToFile(Widget w,FILE *f);
void ComboBoxAddCallback(Widget w,XtCallbackProc f,void *d);

