#define _DEBUG_ 1

/* REMEMBER: You can use FinalCheck(); when you leave the program to
   display memory leaks and open files */

#include "jbdbg.h"

#include <stdio.h>
#include <signal.h>
#include "hashtab.h"

extern HashTable ht;

void Terminate(int sig)
{
  printf("Terminate called with signal %d\n",sig);
}


void Proc3(void)
{
  SP("Proc3");
  db_strcpy(NULL,"jghsdfgjsdkfghjksdfgd");
  EP;
}

void Proc2(char *ptr)
{
  SP("Proc2");
  Proc3();
  db_strcpy(ptr,"jghsdfgjsdkfghjksdfgd");
  EP;
}
  
void Proc1(void)
{
  SP("Proc1");
  Proc2(NULL);
  EP;
}

int main(void)
{
  char *ptr,str1[100]="Hallo",str2[100]="Testing",*str,ptr1[100],ptr2[100],b[100],*ptr3[10000];
  int x,f,y;
  char chr=0;
  FILE *file,*f2;
  int files[2];
  struct dirent **sbuf;
  struct stat st;
  struct timeval tv={0,1};
  
  SP("main");
  DBInit("tst","tstlog",0,Terminate);
  Log("Starting tst");
  db_verbose=1;
  
  for (x=0;x<10000;x++)
  {
    if ((ptr3[x]=(char*)db_malloc(1))==NULL)
      Terminate(0);
  }
  for (x=0;x<10000;x+=2)
    db_free(ptr3[x]);
  for (x=1;x<10000;x+=2)
    db_free(ptr3[x]);
  for (x=0;x<10000;x++)
    if ((ptr3[x]=(char*)db_malloc(1))==NULL)
      Terminate(0);
  for (x=0;x<10000;x+=2)
    db_free(ptr3[x]);
  for (x=1;x<10000;x+=2)
    db_free(ptr3[x]);
  for (x=0;x<10000;x++)
    if ((ptr3[x]=(char*)db_malloc(1))==NULL)
      Terminate(0);
  for (x=0;x<10000;x+=2)
    db_free(ptr3[x]);
  for (x=1;x<10000;x+=2)
    db_free(ptr3[x]);
  ptr=db_malloc(100);
  ptr=db_realloc(ptr,50);
  db_free(ptr);
  ptr=db_calloc(100,1);
  db_strcpy(str1,str2);
  db_strncpy(str1,str2,50);
  db_strcmp(str1,str2);
  str=db_strdup(str1);
  db_memchr(ptr,1,100);
  db_memcmp(ptr1,ptr2,100);
  db_memcpy(ptr1,ptr2,100);
  db_memmove(ptr1,ptr2,100);
  db_memset(ptr,chr,100);
  db_strcat(str1,str2);
  db_strchr(str,chr);
  db_strcspn(str1,str2);
  db_strlen(str);
  str[0]=0;
  db_strncat(str,str2,1);
  db_strncmp(str,str2,0);
  db_strpbrk(str,str2);
  db_strrchr(str,chr);
  db_strspn(str,str2);
  db_strstr(str,str2);
  db_strtok(str,str2);

  f=db_creat("tstfile1",2);
  file=db_fopen("tstfile2","w");
  db_fprintf(file,"str=%s\n",str);
  db_sprintf(str2,"str=%s\n",str);
  db_fscanf(file,"str=%s\n",str);
  db_sscanf(str2,"str=%s\n",str);
  db_clearerr(file);
  db_feof(file);	
  db_ferror(file);
  db_fflush(file);
  db_fgetc(file);
  db_fgets(str,100,file);
  db_fputc(chr,file);
  db_fputs(str,file);
  db_fread(b,100,1,file);
  db_fseek(file,0,0);
  db_ftell(file);
  db_fwrite(b,1,100,file);
  db_getc(file);
  db_lseek(f,0,0);
  db_open("tstfile2",0);
  db_putc(chr,file);
  db_read(f,b,1);
  db_remove("tstfile3");
  db_rename(str,str2);
  db_rewind(file);
  db_setbuf(file,NULL);
  db_setvbuf(file,b,1,1);
  db_tmpnam(str2);
  f2=db_tmpfile();
  db_fclose(f2);
  db_ungetc(chr,file);
  db_unlink("tstfile3");
  db_write(f,b,1);
  db_close(f);
  file=db_freopen("tstfile3","w",file);
 
  str=db_realloc(str,256);
  db_pipe(files);
  db_dup(files[0]);
  db_dup2(f,f);
  db_fdopen(f,"r");
  db_fstat(f,&st);
  db_lstat(".",&st);
  db_stat(".",&st);
  db_access(".",0);
  db_opendir(".");
  db_readdir(NULL);
  db_closedir(NULL);
  db_chmod("dfgdf",0);
  db_fchmod(f,0);
  db_chown("dsg",9,8);
  db_fchown(f,7,6);
  db_chdir(".");
  db_fchdir(f);
  db_rmdir("gsdg");
  db_truncate("5645",4);
  db_ftruncate(f,5);
  db_mkdir("tstdir",0666);
  db_link("fgdfh","asgf");
  db_select(0,NULL,NULL,NULL,&tv);
  db_popen("ls","r");
  db_pclose(NULL);
  f=db_socket(1,1,1);
  db_bind(f,(void*)str,1);
  db_recv(f,str,1,1);
  db_send(f,str,1,1);
  db_listen(f,1);
  db_shutdown(f,2);
  db_accept(f,NULL,NULL);
  db_connect(f,NULL,0);
  db_sendto(f,(void*)str,1,1,NULL,0);
  db_recvfrom(f,(void*)str,1,1,NULL,0);
  db_getcwd(str,1);
  y=db_scandir(".",&sbuf,NULL,(void*)alphasort);
  for (x=0;x<y;x++)
    db_free(sbuf[x]);
/*  db_fclose(file); */
/*  db_free(ptr);*/
  db_free(str);
  
  Proc1();
  EP;
  return 0;
}
  
  

