#include "jex.h"
#include <ctype.h>
#include <Xm/List.h>

int FindFileLine(char *str,Editor *e,char *file,int *l)
{
  int x;
  
  if (e->grepped)
    return sscanf(str,"%[^:]:%d:",file,l);
  for (x=0;x<e->ce_count;x++)
  {
    if (sscanf(str,e->compiler_error[x],file,l)==2)
      return 2;
  }
  return 0;
}

void GotoError(Widget w,Editor *e,void *cbs)
{
  char *str;
  char file[255]/*,dir[255],name[255],name2[255]*/;
  int line,x;
  XmStringTable selected_items;
  int num_selected,res;
  
SP("GotoError");
  XtVaGetValues(e->io_win,XmNselectedItemCount,&num_selected,XmNselectedItems,&selected_items,NULL);
  if (num_selected==0)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XmStringGetLtoR(selected_items[0],XmSTRING_DEFAULT_CHARSET,&str);
  res=FindFileLine(str,e,file,&line);
  if (res==2)
  {
/*    SplitPath(file,dir,name2);*/
    GetFullFileName(file);
    for (x=0;x<editors;x++)
    {
     /* SplitPath(editor[x]->filename,dir,name);
      if (db_strcmp(name,name2)==0)*/
      if (db_strcmp(editor[x]->filename,file)==0)
      {
        XMapRaised(XtDisplay(editor[x]->shell),XtWindow(editor[x]->shell));
        if (res==2)
        {
          sprintf(file,"%d",line);
          XtVaSetValues(editor[x]->gotofield,XmNvalue,file,NULL);
          GotoLine(NULL,editor[x],NULL);
        }
        XtFree(str);
        WatchCursor(e,0);
        EP;
        return;
      }
    }
    CreateNewEditor();
 /*   db_strcpy(editor[editors-1]->filename,file);
    SetTitle(editor[editors-1],editor[editors-1]->filename);*/
    if (loadfile(editor[editors-1],file,0,1))
      LoadError(editor[editors-1]);
    if (res==2)
    {
      sprintf(file,"%d",line);
      XtVaSetValues(editor[editors-1]->gotofield,XmNvalue,file,NULL);
      GotoLine(NULL,editor[editors-1],NULL);
    }
    XtFree(str);
    WatchCursor(e,0);
    EP;
    return;
  }      
  WatchCursor(e,0);
EP;
}
