#include <Xm/MessageB.h>
#include "jex.h"

extern Widget top;
Widget he=NULL;

void LoadError(Editor *e)
{
SP("LoadError");
  if (e->le==NULL)
  {
    e->le=XmCreateErrorDialog(e->shell,"LoadError",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(e->le,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(e->le,XmDIALOG_HELP_BUTTON));
  }
  XtManageChild(e->le);
  SetCurrentWidget(e->text);
EP;
}

void ShowError(Editor *e,char *errstr)
{
  XmString xstr;

SP("ShowError");
  if (e->err==NULL)
  {
    e->err=XmCreateErrorDialog(e->shell,"ErrorDialog",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(e->err,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(e->err,XmDIALOG_HELP_BUTTON));
  }
  xstr=XmStringCreateLocalized(errstr);
  XtVaSetValues(e->err,XmNmessageString,xstr,NULL);
  XmStringFree(xstr);
  XtManageChild(e->err);
EP;
}

void SaveError(Editor *e)
{
SP("SaveError");
  if (e->se==NULL)
  {
    e->se=XmCreateErrorDialog(e->shell,"SaveError",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(e->se,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(e->se,XmDIALOG_HELP_BUTTON));
  }
  XtManageChild(e->se);
  SetCurrentWidget(e->text);
EP;
}

void HelpError(char *msg)
{
  XmString xstr;
  
SP("HelpError");
  if (he==NULL)
  {
    he=XmCreateErrorDialog(top,"HelpError",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(he,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(he,XmDIALOG_HELP_BUTTON));
  }
  xstr=XmStringCreateLocalized(msg);
  XtVaSetValues(he,XmNmessageString,xstr,NULL);
  XmStringFree(xstr);
  XtManageChild(he);
EP;
}


