#include <Xm/MessageB.h>
#include "jex.h"
#include "list.h"

extern Widget top;
extern XtAppContext app;

void ReallyShowVersion(void)
{
  Widget w;
  XmString xstr;
  char str[100];
  
SP("ReallyShowVersion");
  w=XmCreateInformationDialog(top,"VersionDialog",NULL,0);
  XtUnmanageChild(XmMessageBoxGetChild(w,XmDIALOG_CANCEL_BUTTON));
  XtUnmanageChild(XmMessageBoxGetChild(w,XmDIALOG_HELP_BUTTON));
  sprintf(str,"You are now using version %d.%d.%d of jex, please look at the help to see what's new.",MAJOR_VERSION,MINOR_VERSION,SUB_MINOR_VERSION);
  xstr=XmStringCreateLocalized(str);
  XtVaSetValues(w,XmNmessageString,xstr,NULL);
  XmStringFree(xstr);
  XtManageChild(w);
EP;
}

void ShowVersion(void)
{
SP("ShowVersion");
  XtAppAddTimeOut(app,500,(XtTimerCallbackProc)ReallyShowVersion,NULL);
EP;
}

void CheckVersion(char *version)
{
  int major,minor,sub_minor;
  
  SP("ShowVersion");
  if (version)
  {
    if (sscanf(version,"%d.%d.%d",&major,&minor,&sub_minor)==3)
    {
      if (major<MAJOR_VERSION)
        ShowVersion();
      else if (major==MAJOR_VERSION && minor<MINOR_VERSION)
        ShowVersion();
      else if (major==MAJOR_VERSION && minor==MINOR_VERSION && sub_minor<SUB_MINOR_VERSION)
        ShowVersion();
    }
  }
  else
    ShowVersion();
  EP;
}

